const db = require("../db");
const authwrap = require("./authwrap");
const check_permissions = require("./helpers/check_permissions");

const get_history = async (msg, respond) => {
  if (msg.before && isNaN(Number(msg.before))) {
    return respond({
      success: false,
      message: "before must be a number",
    });
  }
  if (!msg.thread) {
    return respond({
      success: false,
      message: "thread ID required",
    });
  }
  if (!(await check_permissions(msg.auth_user.id, msg.thread)).view) {
    return respond({
      success: false,
      message: "you can't view this thread",
    });
  }
  const messages = await db.query(
    `select users.name, posts.id, content from posts
    join users on posts.user = users.id
    ${msg.before ? "where posts.id < ? and" : "where"}
    thread = ?
    order by posts.created desc
    limit 101`,
    msg.before ? [msg.before, msg.thread] : [msg.thread]
  );
  return respond({
    success: true,
    messages: messages.rows
      .slice(0, 100)
      .map((i) => ({ id: i.id, name: i.name, message: i.content })),
    more: messages.rows.length > 100,
  });
};

module.exports = authwrap(get_history);
