const db = require("../db");
const authwrap = require("./authwrap");
const check_permissions = require("./helpers/check_permissions");

const list_threads = async (msg, respond) => {
  const threads = await db.query(
    `select name, id, members.key_delivery as key from threads
    join permissions on threads.id = permissions.thread
    left join members on threads.id = members.thread
    where permissions.permission = 'view'
    and permissions.value = 'true'
    and ((permissions.type = 'everyone') or
      permissions.type = 'members' and members.user = ?)
    group by threads.id
    order by threads.created desc`,
    [msg.auth_user.id]
  );
  // respond
  const rows = [];
  for (let i of threads.rows) {
    rows.push({
      ...i,
      permissions: await check_permissions(msg.auth_user.id, i.id),
    });
  }
  return respond({
    success: true,
    threads: rows,
  });
};

module.exports = authwrap(list_threads);
